require(['config'], function() {
	require([
		'jquery'
	], function($) {

	});
});

let NK_OPTION_GRP_GRID_LIST = '/api/nk/option/grid-list';

function itp_fn_BIZPOP_NK_OPTION_GRP(parentPopFn, schParam, returnType) {
	
	// 브랜드그룹코드
	$('#ITP_FORM_BIZPOP_NK_OPTION_GRP_CMPY_CD').val(schParam.cmpyCd);
	$('#ITP_FORM_BIZPOP_NK_OPTION_GRP_BRAND_CD').val(schParam.brandCd);
	$('#ITP_FORM_BIZPOP_NK_OPTION_GRP_STORE_NO').val(schParam.storeNo);
	
	// 공통코드
	fn_make_select(CODE_LIST, 'USE_YN', 'ITP_FORM_NK_OPTION_GRP_USE_YN');
	
	let itp_BIZPOP_NK_OPTION_GRP_param = {};
	let itp_BIZPOP_NK_OPTION_GRP_search = false;

	const THIS_FORM_ID = '#ITP_FORM_BIZPOP_NK_OPTION_GRP';
	const THIS_GIRD_ID = '#ITP_BIZPOP_NK_OPTION_GRP_jqGrid';
	const THIS_GIRD_PAGER = '#ITP_BIZPOP_NK_OPTION_GRP_jqGridPager';
	
	$('#ITP_BIZPOP_NK_OPTION_GRP').one('shown.bs.modal', function(e) {
		itp_fn_jqgrid_resize(THIS_GIRD_ID, '#ITP_BIZPOP_NK_OPTION_GRP_jqGrid_list', '');
		itp_fn_fire_window_resize();
	}).one('hidden.bs.modal', function(e) {
		$('#ITP_BIZPOP_NK_OPTION_GRP').remove();
	}).modal('show');

	$('#ITP_BIZPOP_NK_OPTION_GRP_BTN_SEARCH').on('click', function() {
		itp_BIZPOP_NK_OPTION_GRP_search = true;
		let param = $(THIS_FORM_ID).serializeObject();
		param.gridSize = 10;
		param.gridPage = $.jgrid.defaults.page;
		$(THIS_GIRD_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
	});
	
	$('#ITP_BIZPOP_NK_OPTION_GRP_BTN_SELECT').on('click', function() {		
		const rowKey = $(THIS_GIRD_ID).getGridParam('selrow');
	    if (!rowKey) {
	    	return;
	    }

		var list = [];
	    var selectedIds = $(THIS_GIRD_ID).getGridParam('selarrrow');
		
	    for (var i=selectedIds.length-1; i>=0; i--) {
			list.push($(THIS_GIRD_ID).jqGrid('getRowData', selectedIds[i]));	
		}
		parentPopFn(list);
		$('#ITP_BIZPOP_NK_OPTION_GRP').modal('hide'); // 팝업닫기
	});

	$('#ITP_BIZPOP_NK_OPTION_GRP_jqGridEmpty').on('click', function() {
		itp_fn_BIZPOP_NK_OPTION_GRP_empty.back();
		itp_BIZPOP_NK_OPTION_GRP_param.gridSize = 10;
		$(THIS_GIRD_ID).setGridParam({'postData': JSON.stringify(itp_BIZPOP_NK_OPTION_GRP_param)}).trigger('reloadGrid');
	});

	var itp_fn_BIZPOP_NK_OPTION_GRP_empty = {
		push: function() {
			let param = $(THIS_FORM_ID).serializeObject();
			itp_BIZPOP_NK_OPTION_GRP_param = param;
		},
		back: function() {
			$(THIS_FORM_ID + '_CLASS_CD').val(itp_BIZPOP_NK_OPTION_GRP_param.sclassCd);
			$(THIS_FORM_ID + '_PRDT_NM').val(itp_BIZPOP_NK_OPTION_GRP_param.sprdtNm);
			$(THIS_FORM_ID + '_BARCODE_NO').val(itp_BIZPOP_NK_OPTION_GRP_param.sbarcodeNo);
		}
	};

	itp_fn_BIZPOP_NK_OPTION_GRP_empty.push();
	let param = $('#ITP_FORM_BIZPOP_NK_OPTION_GRP').serializeObject();
	param.gridSize = 10;

	$(THIS_GIRD_ID).jqGrid({
		colModel: [
			{
				index: 'OPT_GP_CD', name: 'optGpCd',
				label: '옵션그룹코드', 
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'OPT_GP_FULL_NM', name: 'optGpFullNm',
				label: '관리옵션그룹명', 
				width: '15', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'OPT_GP_NM', name: 'optGpNm',
				label: '옵션그룹명', 
				width: '15', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'USE_YN_NM', name: 'useYnNm',
				label: '사용여부', 
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			}
		],
		loadBeforeSend: function(jqXHR) {
		    jqXHR.setRequestHeader('X-AUTH-TOKEN', CONN_KEY);
		},
		postData: JSON.stringify(param),
		url: DOMAIN + NK_OPTION_GRP_GRID_LIST,
		pager: THIS_GIRD_PAGER,
		multiselect: true,
		loadComplete: function(data) {
			itp_fn_grid_load_complete(data, THIS_GIRD_ID, true, undefined, 'BIZPOP_NK_OPTION_GRP', itp_BIZPOP_NK_OPTION_GRP_search, itp_fn_BIZPOP_NK_OPTION_GRP_empty, true, data.gridRecords, false);
	    },
	    loadError: function(jqXHR, textStatus, errorThrown) {
	    	itp_fn_grid_load_error(jqXHR, textStatus, errorThrown);
	    },
	    onPaging: function(action) {
	    	itp_fn_grid_paging(THIS_GIRD_ID, action, param);
	    }
	}).navGrid(THIS_GIRD_PAGER, ITP_GRID_NAV_DEFAULTS.navGrid);
};
